
%    ---------------------------------------------------------------------
%
%    MATLAB/MEX Generalized seam carving      
%    Copyright (C) 2011 Alex Mansfield (alex.mansfield@vision.ee.ethz.ch)
%
%    This program is free software: you can redistribute it and/or modify
%    it under the terms of the GNU General Public License as published by
%    the Free Software Foundation, either version 3 of the License, or
%    (at your option) any later version.
%
%    This program is distributed in the hope that it will be useful,
%    but WITHOUT ANY WARRANTY; without even the implied warranty of
%    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%    GNU General Public License for more details.
%
%    You should have received a copy of the GNU General Public License
%    along with this program.  If not, see http://www.gnu.org/licenses/.
%
%    ---------------------------------------------------------------------

function imEnergy = pairwiseAbstract(r, c, u_s, imEnergy, R, currC, fncPairwise,pairwiseorder,blend,imCurr,imMagnitude,imInput,imInputMagnitude,imShift,imNumber)

if(c==1)
    imEnergy(r,c,2) = u_s;
    if(r>1)
        imEnergy(r,c,1) = 0;
        imEnergy(r,c,3) = fncPairwise('curr',2, pairwiseorder, blend, imCurr, imMagnitude, imInput, imInputMagnitude, imShift, imNumber,r-1,c,r,c+1,r,c,r-1,c+1);
    else
        imEnergy(r,c,1) = 0;
        imEnergy(r,c,3) = 0;
    end
elseif((c>1)&&(c<currC))
    imEnergy(r,c,2) = fncPairwise('curr',2, pairwiseorder, blend, imCurr, imMagnitude, imInput, imInputMagnitude, imShift, imNumber,r,c-1,r,c+1,r,c,r,c);
    
    if(r>1)
        imEnergy(r,c,1) = fncPairwise('curr',2, pairwiseorder, blend, imCurr, imMagnitude, imInput, imInputMagnitude, imShift, imNumber,r-1,c,r,c-1,r-1,c-1,r,c);
        imEnergy(r,c,3) = fncPairwise('curr',2, pairwiseorder, blend, imCurr, imMagnitude, imInput, imInputMagnitude, imShift, imNumber,r-1,c,r,c+1,r-1,c+1,r,c);
    else
        imEnergy(r,c,1) = 0;
        imEnergy(r,c,3) = 0;
    end
elseif(c==currC)
    imEnergy(r,c,2) = u_s;
    if(r>1)
        imEnergy(r,c,1) = fncPairwise('curr',2, pairwiseorder, blend, imCurr, imMagnitude, imInput, imInputMagnitude, imShift, imNumber,r-1,c,r,c-1,r,c,r-1,c-1);
        imEnergy(r,c,3) = 0;
    else
        imEnergy(r,c,1) = 0;
        imEnergy(r,c,3) = 0;
    end
end
            
end