
/*    ---------------------------------------------------------------------
 *
 *    MATLAB/MEX Generalized seam carving
 *    Copyright (C) 2011 Alex Mansfield (alex.mansfield@vision.ee.ethz.ch)
 *    This program is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program.  If not, see http://www.gnu.org/licenses/.
 *
 *    ---------------------------------------------------------------------
 */

#include "sc.h"

#include <stdlib.h>
#include <stdio.h>

int sc_pairwiseabstract(int const r, int const c, int const R, int const currC, int const C, double const un_small, absPairwise const * const fncPairwise, double const pairwiseorder, double const blend, double const * const imCurr, double const * const imMagnitude, double const * const imInput, double const * const imInputMagnitude, int const * const imShift, int const * const imNumber, double * const imEnergy) {

  int vecR[4], vecC[4];

  if(c==0) {
    imEnergy[index3(r,c,1,R,C)] = un_small;
    if(r>0) {
      imEnergy[index3(r,c,0,R,C)] = 0.0;
      vecR[0] = r-1; vecC[0] = c;
      vecR[1] = r; vecC[1] = c+1;
      vecR[2] = r-1; vecC[2] = c+1;
      vecR[3] = r; vecC[3] = c;
      imEnergy[index3(r,c,2,R,C)] = (*fncPairwise)(R,currC,C,0,2,pairwiseorder,blend,imCurr,imMagnitude,imInput,imInputMagnitude,imShift,imNumber,vecR,vecC); 
    } else {
      imEnergy[index3(r,c,0,R,C)] = 0.0;
      imEnergy[index3(r,c,2,R,C)] = 0.0;
    }
  } else if((c>0)&&(c<(currC-1))) {
    vecR[0] = r; vecC[0] = c-1;
    vecR[1] = r; vecC[1] = c+1;
    vecR[2] = r; vecC[2] = c;
    vecR[3] = r; vecC[3] = c;
    imEnergy[index3(r,c,1,R,C)] = (*fncPairwise)(R,currC,C,0,2,pairwiseorder,blend,imCurr,imMagnitude,imInput,imInputMagnitude,imShift,imNumber,vecR,vecC);
    if(r>0) {
      vecR[0] = r-1; vecC[0] = c;
      vecR[1] = r; vecC[1] = c-1;
      vecR[2] = r-1; vecC[2] = c-1;
      vecR[3] = r; vecC[3] = c;
      imEnergy[index3(r,c,0,R,C)] = (*fncPairwise)(R,currC,C,0,2,pairwiseorder,blend,imCurr,imMagnitude,imInput,imInputMagnitude,imShift,imNumber,vecR,vecC); 
      vecR[1] = r; vecC[1] = c+1;
      vecR[2] = r-1; vecC[2] = c+1;
      imEnergy[index3(r,c,2,R,C)] = (*fncPairwise)(R,currC,C,0,2,pairwiseorder,blend,imCurr,imMagnitude,imInput,imInputMagnitude,imShift,imNumber,vecR,vecC); 
    } else {
      imEnergy[index3(r,c,0,R,C)] = 0.0;
      imEnergy[index3(r,c,2,R,C)] = 0.0;
    }
  } else if(c==(currC-1)) {
    imEnergy[index3(r,c,1,R,C)] = un_small;
    if(r>0) {
      vecR[0] = r-1; vecC[0] = c;
      vecR[1] = r; vecC[1] = c-1;
      vecR[2] = r-1; vecC[2] = c-1;
      vecR[3] = r; vecC[3] = c;
      imEnergy[index3(r,c,0,R,C)] = (*fncPairwise)(R,currC,C,0,2,pairwiseorder,blend,imCurr,imMagnitude,imInput,imInputMagnitude,imShift,imNumber,vecR,vecC); 
      imEnergy[index3(r,c,2,R,C)] = 0.0;
    } else {
      imEnergy[index3(r,c,0,R,C)] = 0.0;
      imEnergy[index3(r,c,2,R,C)] = 0.0;
    }
  }
 
  return 1;

}
