
/*    ---------------------------------------------------------------------
 *
 *    MATLAB/MEX Generalized seam carving
 *    Copyright (C) 2011 Alex Mansfield (alex.mansfield@vision.ee.ethz.ch)
 *    This program is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program.  If not, see http://www.gnu.org/licenses/.
 *
 *    ---------------------------------------------------------------------
 */ 

#include "sc.h"
#include <string.h>
#include <math.h>

double shift1(int const R, int const C, int const it, int const domain, int const term, int const shiftweight, int const * const imShift, double const * const imInputUnary, int const * const r, int const * const c) {

if(domain==0) {
    // Curr
    if(term==1) {
      return shiftweight * pow((double)imShift[index2(r[0],c[0],R)] - (double)imShift[index2(r[1],c[1],R)],2.0);
    } else if(term==2) {
      return shiftweight * pow((double)imShift[index2(r[0],c[0],R)],2.0);
    } else if(term==3) {
      return shiftweight * pow((double)it - (double)imShift[index2(r[0],c[0],R)],2.0);
    } else {
      return shiftweight * pow((double)imShift[index2(r[0],c[0],R)] - (double)imShift[index2(r[1],c[1],R)],2.0);
    }
  } else {
    // Input
    if(term==1) {
      return shiftweight * pow((double)c[1]-(double)c[0],2.0);
    } else if(term==2) {
      return shiftweight * pow((double)c[0]-1.0,2.0);
    } else if(term==3) {
      return shiftweight * pow((double)C-(double)c[0],2.0);
    } else {
      return shiftweight * pow((double)c[1]-(double)c[0],2.0);
    }
  }
} 
