
/*    ---------------------------------------------------------------------
 *
 *    MATLAB/MEX Generalized seam carving
 *    Copyright (C) 2011 Alex Mansfield (alex.mansfield@vision.ee.ethz.ch)
 *    This program is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program.  If not, see http://www.gnu.org/licenses/.
 *
 *    ---------------------------------------------------------------------
 */ 

#include "sc.h"

#include <stdlib.h>
#include <stdio.h>

int sc_shiftabstract(int const r, int const c, int const R, int const currC, int const C, int const it, double const shiftweight, int const * const imShift, double const * const imInputUnary, absShift const * const fncShift, absOp const * const fncShiftOpV, absOp const * const fncShiftOpH, double * const imEnergy) {

  int vecR[2], vecC[2];

  if(!fncShift->null()) {
    if(!fncShiftOpH->null()) {
      if(c==0) {
	vecR[0] = r; vecC[0] = c+1;
	imEnergy[index3(r,c,1,R,C)] = (*fncShiftOpH)(imEnergy[index3(r,c,1,R,C)],(*fncShift)(R,C,it,0,2,shiftweight,imShift,imInputUnary,vecR,vecC));
      } else if(c==(currC-1)) {
	vecR[0] = r; vecC[0] = c-1;
	imEnergy[index3(r,c,1,R,C)] = (*fncShiftOpH)(imEnergy[index3(r,c,1,R,C)],(*fncShift)(R,C,it,0,3,shiftweight,imShift,imInputUnary,vecR,vecC));
      } else {
	vecR[0] = r; vecC[0] = c-1;
	vecR[1] = r; vecC[1] = c+1;
	imEnergy[index3(r,c,1,R,C)] = (*fncShiftOpH)(imEnergy[index3(r,c,1,R,C)],(*fncShift)(R,C,it,0,1,shiftweight,imShift,imInputUnary,vecR,vecC));
      }
    }

    if(!fncShiftOpV->null()) {
      if((c>0)&&(r>0)) {
	vecR[0] = r-1; vecC[0] = c;
	vecR[1] = r; vecC[1] = c-1;
	imEnergy[index3(r,c,0,R,C)] = (*fncShiftOpV)(imEnergy[index3(r,c,0,R,C)],(*fncShift)(R,C,it,0,4,shiftweight,imShift,imInputUnary,vecR,vecC));
      }
      if((c<(currC-1))&&(r>0)) {
	vecR[0] = r-1; vecC[0] = c;
	vecR[1] = r; vecC[1] = c+1;
	imEnergy[index3(r,c,2,R,C)] = (*fncShiftOpV)(imEnergy[index3(r,c,2,R,C)],(*fncShift)(R,C,it,0,4,shiftweight,imShift,imInputUnary,vecR,vecC));
      }
    }
  } 
 
  return 1;

}
